#!BPY

# """
# Name: 'Lsystem (hu)'
# Blender: 243
# Group: 'Wizards'
# Tooltip: 'Blender Tree-maker Script ver1.30 (hu)'
# """
__author__ = '2001-2005 Armagan YAVUZ (translated: MsV)'
__version__ = '1.30.msv'
__url__ = ["www.geocities.com/blenderdungeon/", "blenderdungeon"]
__email__ = ["msv@freemail.hu"]
__bpydoc__ = """\

######################################
#  Blender Tree-maker Script ver1.30
#
#  2001-2005 Armagan YAVUZ
#  
#  Latest version can be obtained from:
#        www.geocities.com/blenderdungeon/
#
#  This script is public domain. You can copy,
# distribute, and modify it in any way you like.
# But please keep the information above intact.
# 
######################################
#                                    #
# PRESS ALT+P TO ACTIVATE THE SCRIPT #
#                                    #
######################################
#
# Modify the line below to set a default directory 
# Make sure you use forward slashes: 
# i.e. use  /  and not  \  
##########################

"""

defaultdir = "./fa"

import Blender
from lsystem import *
from rulesets import *
from stemRules import *
from leafRules import *
from Blender.Draw import *
from Blender.BGL import *
from string import strip
from Blender import Library


version = 130

orientation = Create(0.5)
force = [Create(0.0), Create(90.0), Create(0.0)]
scaleforce = Create(0.0)
iteration= Create(6)
resolutionLOD= Create(0.66)
resolution= Create(16)
resolutionV= Create(2)
stemresolutionV= Create(2)
leafresolutionV= Create(1)
repeat= Create(1)
stemrepeat= Create(3)
leafrepeat= Create(1)
bangle = Create(70.0)
stembangle = Create(66.0)
leafbangle = Create(90.0)
menu= Create(7)
stemmenu= Create(7)
leafmenu= Create(7)
leafname= Create("a")
useleaf = Create(1)
leafscale = Create(1.0)
thickness = Create(0.1)
length = Create(0.5)
leaflength = Create(1.0)
rotF = Create(24.0)
stemrotF = Create(56.0)
leafrotF = Create(0.0)
curve = Create(64.0)
stemcurve = Create(0.0)
leafcurve = Create(0.0)
stemorientation = Create(0.0)
conism = Create(0.05)
shorten = Create(0.05)
branch_scale = Create(0.75)
stembranch_scale = Create(0.75)
lenscale = Create(1.0)
stemlenscale = Create(1.0)
prune = Create(0.0)
prunefirst = Create(1)
rot_rand_per = Create(0.1)
rot_rand_abs = Create(0.1)
leafbank = Create(0.0)
maxdepth = Create(30)
randScale = Create(0.1)
prune_level = Create(6)

message = "Ksz"

filename = Create(defaultdir)

def writeln(f,x):
  f.write(str(x))
  f.write("\n")

def readint(f):
  return int(f.readline())
def readfloat(f):
  return float(f.readline())
def readstr(f):
  s = (f.readline())
  return strip(s)

def do_file(save):
  fname = filename.val
  global message, iteration, orientation, menu, stemmenu,leafmenu,thickness, length, leaflength, rotF, stemrotF, leafrotF,conism , branch_scale, stembranch_scale, lenscale, stemlenscale
  global prune, prunefirst, resolutionLOD, resolution, resolutionV, stemresolutionV, leafresolutionV, repeat, stemrepeat, leafrepeat, rot_rand_per,rot_rand_abs,leafname,useleaf,leafscale
  global force,scaleforce,bangle,stembangle,leafbangle
  global curve,stemcurve,leafcurve,stemorientation,leafbank,shorten,maxdepth
  # version 1.2
  global randScale, prune_level

  if save:  message = "Fjl elmentve."
  else:     message = "Fjl betltve."

  if save:
    try:
      f = open(fname,'w')
    except:
      message = "Fjl nem menthet."
      return
  else:
    try:
      f = open(fname,'r')
    except:
      message = "A fjlt nem tallom."
      return

  if save:  writeln(f,version)
  else:
    file_version = readint(f)
    if version != file_version:
      message = "Eltr verzi!"
  if save:  writeln(f,iteration.val)
  else:     iteration.val = readint(f)

  if save:  writeln(f,orientation.val)
  else:     orientation.val = readfloat(f)
  if save:  writeln(f,stemorientation.val)
  else:     stemorientation.val = readfloat(f)

  if save:  writeln(f,menu.val)
  else:     menu.val = readint(f)
  if save:  writeln(f,stemmenu.val)
  else:     stemmenu.val = readint(f)
  if save:  writeln(f,leafmenu.val)
  else:     leafmenu.val = readint(f)

  if save:  writeln(f,thickness.val)
  else:     thickness.val = readfloat(f)

  if save:  writeln(f,length.val)
  else:     length.val = readfloat(f)
  if save:  writeln(f,leaflength.val)
  else:     leaflength.val = readfloat(f)

  if save:  writeln(f,rotF.val)
  else:     rotF.val = readfloat(f)
  if save:  writeln(f,stemrotF.val)
  else:     stemrotF.val = readfloat(f)
  if save:  writeln(f,leafrotF.val)
  else:     leafrotF.val = readfloat(f)

  if save:  writeln(f,conism.val)
  else:     conism.val = readfloat(f)

  if save:  writeln(f,branch_scale.val)
  else:     branch_scale.val = readfloat(f)
  if save:  writeln(f,stembranch_scale.val)
  else:     stembranch_scale.val = readfloat(f)
  if save:  writeln(f,lenscale.val)
  else:     lenscale.val = readfloat(f)
  if save:  writeln(f,stemlenscale.val)
  else:     stemlenscale.val = readfloat(f)

  if save:  writeln(f,prune.val)
  else:     prune.val = readfloat(f)
  if save:  writeln(f,prunefirst.val)
  else:     prunefirst.val = readint(f)

  if save:  writeln(f,resolutionLOD.val)
  else:     resolutionLOD.val = readfloat(f)
  if save:  writeln(f,resolution.val)
  else:     resolution.val = readint(f)
  if save:  writeln(f,resolutionV.val)
  else:     resolutionV.val = readint(f)
  if save:  writeln(f,stemresolutionV.val)
  else:     stemresolutionV.val = readint(f)
  if save:  writeln(f,repeat.val)
  else:     repeat.val = readint(f)
  if save:  writeln(f,stemrepeat.val)
  else:     stemrepeat.val = readint(f)
  if save:  writeln(f,leafrepeat.val)
  else:     leafrepeat.val = readint(f)

  if save:  writeln(f,rot_rand_per.val)
  else:     rot_rand_per.val = readfloat(f)
  if save:  writeln(f,rot_rand_abs.val)
  else:     rot_rand_abs.val = readfloat(f)

  if save:  writeln(f,leafname.val)
  else:     leafname.val = readstr(f)
  if save:  writeln(f,useleaf.val)
  else:     useleaf.val = readint(f)
  if save:  writeln(f,leafscale.val)
  else:     leafscale.val = readfloat(f)

  if save:  writeln(f,force[0].val)
  else:     force[0].val = readfloat(f)
  if save:  writeln(f,force[1].val)
  else:     force[1].val = readfloat(f)
  if save:  writeln(f,force[2].val)
  else:     force[2].val = readfloat(f)
  if save:  writeln(f,scaleforce.val)
  else:     scaleforce.val = readfloat(f)

  if save:  writeln(f,bangle.val)
  else:     bangle.val = readfloat(f)
  if save:  writeln(f,stembangle.val)
  else:     stembangle.val = readfloat(f)
  if save:  writeln(f,leafbangle.val)
  else:     leafbangle.val = readfloat(f)

  if save:  writeln(f,curve.val)
  else:     curve.val = readfloat(f)
  if save:  writeln(f,stemcurve.val)
  else:     stemcurve.val = readfloat(f)
  if save:  writeln(f,leafcurve.val)
  else:     leafcurve.val = readfloat(f)

  if save:  writeln(f,leafbank.val)
  else:     leafbank.val = readfloat(f)
  if save:  writeln(f,shorten.val)
  else:     shorten.val = readfloat(f)

  if save:  writeln(f,maxdepth.val)
  else:     maxdepth.val = readint(f)

# added in version 1.2
  if save:  writeln(f,randScale.val)
  elif file_version >= 120: randScale.val = readfloat(f)

  if save:  writeln(f,prune_level.val)
  elif file_version >= 120: prune_level.val = readint(f)

  f.close()



def draw():
	global message, iteration, orientation, stemorientation,menu, stemmenu,leafmenu,thickness, length, leaflength, rotF, stemrotF, leafrotF,conism , branch_scale, stembranch_scale, lenscale, stemlenscale, prune, prunefirst, resolutionLOD, resolution, resolutionV, stemresolutionV, leafresolutionV, repeat, stemrepeat, leafrepeat, rot_rand_per,rot_rand_abs,leafname,useleaf,leafscale,force,scaleforce,bangle,stembangle,leafbangle
	global curve,stemcurve,leafcurve,leafbank,shorten,maxdepth,randScale,randThin,prune_level

	global filename

	glClearColor(0.6, 0.6, 0.65, 0.0)
	glClear(GL_COLOR_BUFFER_BIT)

	glColor3f(0.5,0.95,0.5)
	glRasterPos2i(10, 510)
	Text("Tree-maker Script ver1.20(hu) www.geocities.com/blenderdungeon/")

	filename = String("Fjlnv: ",2, 95, 485, 220, 19, filename.val, 50)
	Button("BETLTS", 14, 10, 485, 80, 19)
	Button("ELMENTS", 15, 320, 485, 80, 19)



	glColor3f(0.2,0.2,0.0)
	glRasterPos2i(20, 465)
	Text("gszerkezet:")
	menu= Menu("Kszlet%t| Egyenes %x1| Karos 2D%x10| Karos 3D%x11| Vltottkar 2D%x4| Vltottkar 3D%x12| Elgazs 2D%x2| Elgazs 3D%x3| Kt kar 2D%x5| Kt kar 3D%x6| Vlt 2 karos %x7| 3 elgazs%x8| 3 karos%x9", 2, 100, 461, 100, 18, menu.val,"g ltrehozsi minta")

	orientation= Slider("j irny ", 2, 10, 360, 190, 18, orientation.val, 0.0, 1.0, 0, "Az j gak irnya(g szerkezet fgg)")
	bangle = Slider("Lejts ", 2, 10, 380, 190, 18, bangle.val, 0.0, 180.0, 0, "Kt j g kztti s az eredeti g kztti szg")
	lenscale = Slider("Nyls ", 2, 10, 340, 190, 18, lenscale.val, 0.5, 1.0, 0, "Az j g hossza az elzhz kpest")
	branch_scale = Slider("Fogys ", 2, 10, 320, 190, 18, branch_scale.val, 0.5, 1.0, 0, "Az j g vastagsga az elzhz kpest")
	rotF= Slider("Csavars ", 2, 10, 420, 190, 18, rotF.val, -360.0, 360.0, 0, "A tart g csavarsa")
	curve= Slider("Grbesg ", 2, 10, 400, 190, 18, curve.val, -360.0, 360.0, 0, "Az g grbesge")
	resolutionV= Number("minsg: ", 2, 10, 440, 90, 19, resolutionV.val, 1, 16, "Fggleges felbonts: minden g ennyi egysgbl ll" )
	repeat= Number("ismtls: ", 2, 105, 440, 95, 19, repeat.val, 1, 10, "Ennyiszer ismtldik a minta a kvetkez ciklus eltt")

	glColor3f(0.2,0.1,0.0)
	glRasterPos2i(220, 465)
	Text("Trzs:")
	stemmenu= Menu("Kszlet%t| Nincs %x1| Egyenes%x2| Karos%x3| Vltottkaros%x4| Ktkar%x5| Vltott 2 kar%x6| 3 kar%x7", 2, 280, 461, 120, 18, stemmenu.val, "A trzs szerkezeti kialaktsa")

	if (stemmenu.val != 1):
		stemorientation= Slider("j irny ", 2, 210, 360, 190, 18, stemorientation.val, -180.0, 180.0, 0)
		stembangle = Slider("Lejts ", 2, 210, 380, 190, 18, stembangle.val, 0.0, 180.0, 0)
		stemlenscale = Slider("Nyls ", 2, 210, 340, 190, 18, stemlenscale.val, 0.2, 2.0, 0)
		stembranch_scale = Slider("Fogys ", 2, 210, 320, 190, 18, stembranch_scale.val, 0.2, 1.0, 0)
		stemrotF= Slider("Csavars ", 2, 210, 420, 190, 18, stemrotF.val, -360.0, 360.0, 0)
		stemcurve= Slider("Grbesg ", 2, 210, 400, 190, 18, stemcurve.val, -360.0, 360.0, 0)
		stemresolutionV= Number("minsg: ", 2, 210, 440, 90, 19, stemresolutionV.val, 1, 16)
		stemrepeat= Number("ismtls: ", 2, 305, 440, 95, 19, stemrepeat.val, 1, 30)


	glColor3f(0.0,0.2,0.0)
	glRasterPos2i(220, 300)
	Text("Levelek:")
	leafmenu= Menu("Kszlet%t| gvgen%x1| Aktv pontokon%x7| Vltva oldalra%x2| Vltva elre%x3| Dupla oldalra%x4| Dupla elre%x5| 2 vltva oldalra%x6| 3 elre%x8", 2, 280, 296, 120, 18, leafmenu.val,"Levelek elhelyezkedsi mintja")
	leafrepeat= Number("ismtls: ", 2, 305, 275, 95, 19, leafrepeat.val, 1, 30,"repeat pattern this many times for each branch")
	leafresolutionV= Number("minsg: ", 2, 210, 275, 90, 19, leafresolutionV.val, 1, 1, "Vertical resolution for leaf carrying branches")
	if not (leafmenu.val in [1,7]):
		leafrotF= Slider("Csavars ", 2, 210, 235, 190, 18, leafrotF.val, -90.0, 90.0, 0, "Extra csavarods a levltart gakon")
		leafcurve= Slider("Grbesg  ", 2, 210, 215, 190, 18, leafcurve.val, -90.0, 90.0, 0, "Extra grblet a levltart gakon")
		leafbangle = Slider("Lejts ", 2, 210, 195, 190, 18, leafbangle.val, 0.0, 180.0, 0,"Az g s a levl szge")
		leafbank = Slider("Irny ", 2, 210, 175, 190, 18, leafbank.val, -90.0, 90.0, 0, "A levl irnya")
	leaflength= Slider("Kocsny ", 2, 210, 255, 190, 18, leaflength.val, 0.2, 5.0, 0, "A levktart gak hossznak extra szorzja")

	useleaf = Toggle("Hozzads",2, 210, 155, 80, 19, useleaf.val, "Levelek hozzadsa")
	leafname = String("Tpus: ",2, 300, 155, 100, 19, leafname.val, 12, "A levekelnek modelll szolgl Blender objektum neve (a-r)")
	leafscale= Slider("Nyjts ", 2, 210, 135, 190, 18, leafscale.val, 0.2, 5.0, 0, "A levl mrete")



	glColor3f(0.0,0.0,0.2)
	glRasterPos2i(15, 300)
	Text("Er:")
	scaleforce= Slider("Hatkr ", 2, 50, 295, 150, 18, scaleforce.val, 0.0, 1.0, 0, "A vkony gakra hat er mely mretnl kisebb gakra hasson")
	force[0]= Slider("Helyzet  ", 2, 10, 275, 190, 18, force[0].val, 0.0, 360.0, 0, "Az er vektornak helyzete")
	force[1]= Slider("Emelkeds ", 2, 10, 255, 190, 18, force[1].val, -90.0, 90.0, 0, "Az er vektornak emelkedse")
	force[2]= Slider("Magnitd ", 2, 10, 235, 190, 18, force[2].val, 0.0, 1.0, 0, "Az er vektornak magnitdja")

	glColor3f(0.2,0.0,0.2)
	glRasterPos2i(20, 215)
	Text("Metszs:")
	prune_level= Menu("Szint%t| Mind%x6 | Kettt kivve%x1| Kivve 2-3%x2|  Utols kettt%x4|  Utols%x5", 2, 10, 190, 70, 18, prune_level.val,"restrict pruning to these levels")
	prune = Slider("Esly ", 2, 80, 190, 120, 18, prune.val, 0.0, 0.9, 0, "A jelzett gak lemetszsnek eslye")
	prunefirst =  Number("Alsmetszs: ", 2, 80, 210, 120, 19, prunefirst.val, 0, 29, "Az els n g lemetszse" )
	maxdepth =  Number("Mlysg: ", 2, 100, 170, 100, 19, maxdepth.val, 0, 30, "Maximlis g-szint mlysg")

	glColor3f(0.2,0.2,0.2)
	glRasterPos2i(20, 150)
	Text("Vletlen:")
	randScale = Slider("Mret ", 2, 40, 125, 150, 18, randScale.val, 0.0, 0.5, 0, "Az j gak mretnek intervalluma")
#	randThin = Slider("RnThinDwn ", 2, 40, 125, 150, 18, randThin.val, 0.0, 1.0, 0)
	rot_rand_per = Slider("Irny ",   2, 40, 105, 150, 18, rot_rand_per.val, 0.0, 1.0, 0, "Az j gak irnynak intervalluma")
	rot_rand_abs = Slider("Csavar ", 2, 40, 85,  150, 18, rot_rand_abs.val, 0.0, 1.0, 0, "A fa csavarodsnak intervalluma")

	glColor3f(0.2,0.2,0.2)
	glRasterPos2i(220, 110)
	Text("ltalnos:")
	resolution= Number("minsg: ", 2, 310, 105, 90, 19, resolution.val, 3, 32, "Az g keresztmetszetben tallhat vertexek szma")
	resolutionLOD = Slider("Romls ", 2, 250, 85, 150, 18, resolutionLOD.val, 0.0, 1.0, 0, "A ninsg cskkense az gak vkonyodsval")

	length= Slider("Mret  ", 2, 210, 60, 190, 18, length.val, 0.0, 1.0, 0, "A fa mrete")
	thickness= Slider("Szlessg ", 2, 210, 40, 190, 18, thickness.val, 0.0, 0.5, 0, "A fa szlessge")
	shorten = Slider("Rvidls ", 2, 10, 60, 190, 18, shorten.val, 0.0, 0.2, 0, "Egysges rvidls a fban")
	conism= Slider("Vkonyods ", 2, 10, 40, 190, 18, conism.val, 0.0, 0.2, 0, "Egysges vkonyods a fban")

	glColor3f(0.9,0.95,1.0)
	glRasterPos2i(180, 10)
	Text(message)

	Button("KILPS", 1, 320, 5, 80, 25)
	Button("KSZTS", 3, 10, 5, 80, 25)
	iteration= Number("ciklus: ", 2, 95, 5, 80, 19, iteration.val, 1, 30, "Ciklusok szma a kszts sorn")





def event(evt, val):	
	if (evt== QKEY and not val): Exit()

def bevent(evt):
	global message
	if   (evt== 1): Exit()
	elif (evt== 2): Draw()
	elif (evt== 14): 
			do_file(0)
			Draw()
	elif (evt== 15): 
			do_file(1)
			Draw()
	elif (evt== 3): 
		message = "Alakzat elksztse..."
		Draw()
		leafobj = None
		if (useleaf.val == 1) and (leafname.val != ""):
			leafobj = Blender.Object.Get(leafname.val)
			if not leafobj:
				message = "Levl objektum nem tallhat!"
				Draw()
				return
		deg2rad =  3.1416 / 180.0
		bang = bangle.val * deg2rad
		nrotF = rotF.val * deg2rad / resolutionV.val
		ncurve = curve.val * deg2rad / resolutionV.val
		if menu.val == 1:
			rules = b_straight(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 2:
			rules = b_split2_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 3:
			rules = b_split2_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 4:
			rules = b_fork1_alt_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 5:
			rules = b_fork2_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 6:
			rules = b_fork2_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 7:
			rules = b_fork2_alt(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 8:
			rules = b_split3(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 9:
			rules = b_fork3(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 10:
			rules = b_fork1_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 11:
			rules = b_fork1_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)
		elif menu.val == 12:
			rules = b_fork1_alt_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,orientation.val)

		stemrules = None
		stembang = stembangle.val * 3.1416 / 180.0
		nrotF = stemrotF.val * deg2rad / stemresolutionV.val
		ncurve = stemcurve.val * deg2rad / stemresolutionV.val
		if stemmenu.val == 1:
			pass
		elif stemmenu.val == 2:
			stemrules = s_straight(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 3:
			stemrules = s_fork1(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 4:
			stemrules = s_fork1_alt(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 5:
			stemrules = s_fork2(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 6:
			stemrules = s_fork2_alt(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 7:
			stemrules = s_fork3(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		if stemrules:
			rules[0] = stemrules[0] # copy axiom from stem
			rules[1].extend(stemrules[1])
			rules[2].extend(stemrules[2])

		leafrules = None
		leafbang = leafbangle.val * 3.1416 / 180.0
		leaf_len = leaflength.val * length.val
		nrotF = (leafrotF.val + rotF.val / leafrepeat.val)* deg2rad 
		ncurve = (leafcurve.val + curve.val / leafrepeat.val)* deg2rad 
		if leafmenu.val == 1:
			leafrules = l_endpoint(resolutionV.val,deg2rad * rotF.val / resolutionV.val,deg2rad * curve.val / resolutionV.val,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 7:
			leafrules = l_activepoint(resolutionV.val,deg2rad * rotF.val / resolutionV.val,deg2rad * curve.val / resolutionV.val,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 2:
			leafrules = l_fork1_alt_prl(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 3:
			leafrules = l_fork1_alt_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 4:
			leafrules = l_fork2_prl(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 5:
			leafrules = l_fork2_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 6:
			leafrules = l_fork2_alt_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 8:
			leafrules = l_fork3_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		if leafrules:
			rules[1].extend(leafrules[1])
			rules[2].extend(leafrules[2])

		torad = 3.1415926 / 180.0 
		maxd = 30
		if maxdepth.val > 0:
			maxd = maxdepth.val
		if prune_level.val == 1:
			min_prune_level = 2
			max_prune_level = 30
		elif prune_level.val == 2:
			min_prune_level = 3
			max_prune_level = 30
		elif prune_level.val == 3:
			min_prune_level = 2
			max_prune_level = 2
		elif prune_level.val == 4:
			min_prune_level = iteration.val -2
			max_prune_level = iteration.val -1
		elif prune_level.val == 5:
			min_prune_level = iteration.val -1
			max_prune_level = iteration.val -1
		elif prune_level.val == 6:
			min_prune_level = 1
			max_prune_level = 30
		cart_force = [cos(force[0].val * torad) * cos(force[1].val * torad) * force[2].val, sin(force[0].val * torad) * cos(force[1].val * torad) * force[2].val, sin(force[1].val * torad) * force[2].val]
		lsystem_build(rules[0],rules[1],rules[2],iteration.val,length.val*thickness.val,conism.val,shorten.val,resolution.val,resolutionLOD.val,rot_rand_per.val * 4.0,rot_rand_abs.val * 2.0,randScale.val,prune.val, prunefirst.val, maxd, min_prune_level, max_prune_level, cart_force, scaleforce.val,leafscale.val,leafobj)
		message = "Ksz" 
		Blender.Redraw()
Register(draw, event, bevent)


def f(name):
    scrp = Blender.Get('scriptsdir')
    print scrp
    open_library(scrp+name)

def open_library(name):
   Library.Open(name)
   groups = Library.LinkableGroups()

   for db in groups:
     print "DATABLOCK %s:" % db
     for obname in Library.Datablocks(db):
       print obname

   if 'Object' in groups:
     for obname in Library.Datablocks('Object'):
       Library.Load(obname, 'Object', 0) # note the 0...
     Library.Update()

   Library.Close()
   Blender.Redraw()

try:
    test_object = Blender.Object.Get('trunk')
    test_object = Blender.Object.Get('leaves')
    test_object = Blender.Object.Get('a')
    test_object = Blender.Object.Get('r')
except:	f("/lsystem_hu_lib.blend")
